function big_im = GenerateNPage(N, Nr, Nc, GAP, sim, savefile)
    [SizeX SizeY max_ind] = size(sim);
    big_im = true(Nr*SizeX + (Nr+1)*GAP, (Nc*SizeY + (Nc+1)*GAP + GAP)*N);
    for p=1:N
        for i=1:Nr
            for j=1:Nc
                st_i=(i)*GAP+(i-1)*SizeX +1;
                en_i=(i)*GAP+(i)*SizeX ;
                st_j=(j)*GAP+(j-1)*SizeY +1 +(Nc*SizeY + (Nc+1)*GAP +GAP)*(p-1);
                en_j=(j)*GAP+(j)*SizeY      +(Nc*SizeY + (Nc+1)*GAP +GAP)*(p-1);

                r = ceil(rand()*max_ind);
                if (r>0.9*max_ind)
                   r = CalCharIndex(ceil(rand()*36));
                end
                %big_im(st_i:en_i, st_j:en_j)=sim(:,:,r);
                big_im(st_i:en_i, st_j:en_j)=DistortImage(sim(:,:,r));
            end
        end
    end
    
    if (exist('savefile','var'))
       imwrite(big_im,[savefile,'.png']); 
       disp(['Save ',savefile,'.png successful']);
    end
    
    if (exist('nv','var'))
       big_im = round(imnoise(big_im,'gaussian',nm,nv)); 
    end
end
