function ch_index = CalCharIndex(ch)
    x = [1];
    switch (ch)
        case {'*',0},           x = [1 2 3 4 5 6 7 8 9 10 11 12 13 14];
        case {'A',1},           x = [1 2 3 5 6 8 10];
        case {'B',2},           x = [1 2 3 4 7 8 9];    
        case {'C',3},           x = [1 4 5 6];
        case {'D',4},           x = [1 2 3 4 7 9];
        case {'E',5},           x = [1 4 5 6 8 10];
        case {'F',6},           x = [1 5 6 10];
        case {'G',7},           x = [1 3 4 5 6 8];
        case {'H',8},           x = [2 3 5 6 8 10];
        case {'I',9},           x = [7 9];
        case {'J',10},          x = [2 3 4 5];
        case {'K',11},          x = [5 6 10 11 12];
        case {'L',12},          x = [4 5 6];
        case {'M',13},          x = [2 3 5 6 11 14];
        case {'N',14},          x = [2 3 5 6 12 14];
        case {'O',15},          x = [1 2 3 4 5 6];
        case {'P',16},          x = [1 2 5 6 8 10];
        case {'Q',17},          x = [1 2 3 4 5 6 12];
        case {'R',18},          x = [1 2 5 6 8 10 12];
        case {'S',19},          x = [1 3 4 6 8 10];
        case {'T',20},          x = [1 7 9];
        case {'U',21},          x = [2 3 4 5 6];
        case {'V',22},          x = [5 6 11 13];
        case {'W',23},          x = [2 3 5 6 12 13];
        case {'X',24},          x = [11 12 13 14];
        case {'Y',25},          x = [9 11 14];
        case {'Z',26},          x = [1 4 11 13];
        case {'1',27},          x = [2 3];
        case {'2',28},          x = [1 2 4 5 8 10];
        case {'3',29},          x = [1 2 3 4 8];
        case {'4',30},          x = [2 3 6 8 10];
        case {'5',31},          x = [1 4 6 10 12];
        case {'6',32},          x = [1 3 4 5 6 8 10];
        case {'7',33},          x = [1 2 3];
        case {'8',34},          x = [1 2 3 4 5 6 8 10];
        case {'9',35},          x = [1 2 3 4 6 8 10];
        case {'0',36},          x = [1 2 3 4 5 6 11 13];
    end
    x = x-1;
    y = power(2,x);
    ch_index = sum(y);    
end