function [sim seg_sample] = read_14seg(bit_max)    
    if (~exist('bit_max','var')),
        bit_max = 14;
    end

    disp(['It may take time & memory to generate ', num2str(power(2,bit_max)),' small images ...']);
    for i=1:bit_max
        eval(['seg_', num2str(i,'%02d'), ' = imread(''14seg_', num2str(i,'%02d'), '.png'');']);
    end            
    for i=1:bit_max
        eval(['im_bw = im2bw(seg_',num2str(i,'%02d'),');']);
        seg(:,:,i) = imresize(im_bw,0.1,'nearest'); 
        eval(['clear seg_',num2str(i,'%02d')]);
    end;
    
    if (nargout >= 2)
        seg_sample = im2bw(imread('14seg_00.png'));
    end
            
    max_ind = power(2,bit_max)-1;
    [a b tmp]=size(seg);    
    sim = zeros(a,b,max_ind);
    cap = 1;
    for k=1:bit_max   
        %disp(['Do upto ...',num2str(power(2,k)-1)]);        
        for i=cap:cap*2-1
            if (i==cap)
                sim(:,:,i) = seg(:,:,k);
            else
                sim(:,:,i) = sim(:,:,cap) & sim(:,:,i-cap);
            end
        end        
        cap = cap*2;       
    end
%     for i=1:power(2,bit_max)-1
%         imshow(sim(:,:,i)); title(['image => ',num2str(i)]);
%         pause;
%     end
    
    save segment sim bit_max
    disp('save sim bit_max => segment.m');
end