function big_im = GenerateCharPage(Ncopies, Nr, Nc, GAP, sim, savefile)
    [SizeX SizeY max_ind] = size(sim);
    big_im = ones(Nr*SizeX + (Nr+1)*GAP, (Nc*SizeY + (Nc+1)*GAP));
    ind = 0;
    ShowChar = true;
        for i=1:Nr
            for j=1:Nc
                if (ind >=  Ncopies*37+1), ShowChar=false;  end;
                st_i=(i)*GAP+(i-1)*SizeX +1;
                en_i=(i)*GAP+(i)*SizeX ;
                st_j=(j)*GAP+(j-1)*SizeY +1;
                en_j=(j)*GAP+(j)*SizeY;
                
                if (ShowChar == true)
                    r = CalCharIndex(mod(ind,37));                                        
                else
                    r = ceil(rand()*max_ind);
                end                
                %big_im(st_i:en_i, st_j:en_j)=sim(:,:,r);
                big_im(st_i:en_i, st_j:en_j)=Distortimage(sim(:,:,r));                
                ind = ind+1;
            end
        end
    
        
    if (exist('savefile','var'))
       imwrite(big_im,[savefile,'.png']); 
       disp(['Save ',savefile,'.png successful']);
    end
end

